# -*- coding: utf-8 -*-
## A Plone product to generate quiz. A quiz is a list of questions with the appropriate answer(s).
## Content managers can build quiz easily and present users a report about the errors they did.
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
A Plone product to generate quiz. A quiz is a list of questions with the appropriate answer(s)
"""
__docformat__ = 'restructuredtext'


#Python modules
from math import floor
#
from AccessControl import ClassSecurityInfo
from Products.CMFCore import CMFCorePermissions
# from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.types.ATFolder import ATFolder
from Products.PloneQuiz.config import REZULT_CLASSES, PROJECTNAME, ENABLE_SHOW_ON_ONE_PAGE, ENABLE_IMMEDIATE_CORRECTION
try:
  from Products.LinguaPlone.public import *
except ImportError:
  # No multilingual support
  from Products.Archetypes.public import *



##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Quiz_schema = ATFolder.schema.copy() + Schema((
    BooleanField('showOnOnePage',
        widget = BooleanWidget(
            label = 'Showononepage',
            label_msgid = 'quiz_label_showOnOnePage',
            description_msgid = 'quiz_help_showOnOnePage',
            i18n_domain = 'quiz',
        )
    ),
    BooleanField('immediateCorrection',
        default = False,
        widget = BooleanWidget(
            label = 'Immediate Correction',
            label_msgid = 'quiz_label_immediateCorrection',
            description_msgid = 'quiz_help_immediateCorrection',
            i18n_domain = 'quiz',
        )
    ),
    TextField('defaultRightAnswerMessage',
        default_method = "myTranslate_defaultRightAnswerMessage",
        schemata = "configuration",
        widget = TextAreaWidget(
            label = 'Defaultrightanswermessage',
            label_msgid = 'quiz_label_defaultRightAnswerMessage',
            description_msgid = 'quiz_help_defaultRightAnswerMessage',
            i18n_domain = 'quiz',
        )
    ),
    TextField('defaultWrongAnswerMessage',
        default_method = 'myTranslate_defaultWrongAnswerMessage',
        schemata = "configuration",
        widget = TextAreaWidget(
            label = 'Defaultwronganswermessage',
            label_msgid = 'quiz_label_defaultWrongAnswerMessage',
            description_msgid = 'quiz_help_defaultWrongAnswerMessage',
            i18n_domain = 'quiz',
        )
    ),

    StringField('defaultRelatedPage',
        schemata = "configuration",
        widget = StringWidget(
            label = 'Defaultrelatedpage',
            label_msgid = 'quiz_label_defaultRelatedPage',
            description_msgid = 'quiz_help_defaultRelatedPage',
            i18n_domain = 'quiz',
        ),
        validators = ('None',)
    ),
    StringField('titleVeryGoodScore',
        schemata = "scores",
        widget = StringWidget(
            label = 'Titleverygoodscore',
            label_msgid = 'quiz_label_titleVeryGoodScore',
            description_msgid = 'quiz_help_titleVeryGoodScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('messageVeryGoodScore',
        schemata = "scores",
        widget = TextAreaWidget(
            label = 'Messageverygoodscore',
            label_msgid = 'quiz_label_messageVeryGoodScore',
            description_msgid = 'quiz_help_messageVeryGoodScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
       StringField('titleGoodScore',
        schemata = "scores",
        widget = StringWidget(
            label = 'Titlegoodscore',
            label_msgid = 'quiz_label_titleGoodScore',
            description_msgid = 'quiz_help_VeryGoodScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('messageGoodScore',
        schemata = "scores",
        widget = TextAreaWidget(
            label = 'Messagegoodscore',
            label_msgid = 'quiz_label_messageGoodScore',
            description_msgid = 'quiz_help_messageGoodScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('titleBadScore',
        schemata = "scores",
        widget = StringWidget(
            label = 'Titlebadscore',
            label_msgid = 'quiz_label_titleBadScore',
            description_msgid = 'quiz_help_titleBadScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('messageBadScore',
        schemata = "scores",
        widget = TextAreaWidget(
            label = 'Messagebadscore',
            label_msgid = 'quiz_label_messageBadScore',
            description_msgid = 'quiz_help_messageBadScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('titleVeryBadScore',
        schemata = "scores",
        widget = StringWidget(
            label = 'Titleverybadscore',
            label_msgid = 'quiz_label_titleVeryBadScore',
            description_msgid = 'quiz_help_titleVeryBadScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
   StringField('messageVeryBadScore',
        schemata = "scores",
        widget = TextAreaWidget(
            label = 'Messageverybadscore',
            label_msgid = 'quiz_label_messageVeryBadScore',
            description_msgid = 'quiz_help_messageVeryBadScore',
            i18n_domain = 'quiz',
       ),
       validators = ('None',)
   ),
),
)


Quiz_schema['id'].widget.visible['view'] = 'invisible'
Quiz_schema['id'].widget.visible['edit'] = 'invisible'

#ENABLE_SHOW_ON_ONE_PAGE is set in config.py
# the default value is True
if not ENABLE_SHOW_ON_ONE_PAGE:
    Quiz_schema['showOnOnePage'].widget.visible = {'view': 'invisible', 'edit': 'invisible'}

if not ENABLE_IMMEDIATE_CORRECTION:
    Quiz_schema['immediateCorrection'].widget.visible = {'view': 'invisible', 'edit': 'invisible'}
##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Quiz(ATFolder):
    security = ClassSecurityInfo()#

    __implements__ = ATFolder.__implements__ #+ (INonStructuralFolder,)


    # This name appears in the 'add' box
    archetype_name = 'Quiz'

    meta_type                   = 'Quiz'
    portal_type                 = 'Quiz'
    allowed_content_types       = ['QuizQA']
    filter_content_types        = 1
    global_allow                = 1
    allow_discussion            = 0
    content_icon                = 'plonequiz.gif'
    immediate_view              = 'quiz_view'
    default_view                = 'quiz_view'
    suppl_views                 = ()
    typeDescription             = "Quiz"
    typeDescMsgId               = 'description_edit_quiz'

    actions = (
       {'action':      "string:${object_url}/quiz_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
    )

    aliases = {
        '(Default)'  : 'quiz_view',
        'view'       : '(selected layout)',
        'index.html' : '(selected layout)',
        'edit'       : 'atct_edit',
        'properties' : 'base_metadata',
        'sharing'    : 'folder_localrole_form',
        'gethtml'    : '',
        'mkdir'      : '',
        }
    schema = Quiz_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    #################################


    #Methods
    security.declarePrivate('myTranslate')
    def myTranslate(self, msgid, default):
        return self.translate(msgid, default, domain='quiz')

    security.declarePrivate('myTranslate_defaultRightAnswerMessage')
    def myTranslate_defaultRightAnswerMessage(self):
        return self.myTranslate('quiz_defaultRightAnswerMessage', "Correct answer !")

    security.declarePrivate('myTranslate_defaultWrongAnswerMessage')
    def myTranslate_defaultWrongAnswerMessage(self):
        return self.myTranslate('quiz_defaultWrongAnswerMessage', "Wrong answer")

    security.declareProtected(CMFCorePermissions.View, 'initQuiz')
    def initQuiz(self, reset= None):
        """ Make a list of QA object
        """
        if not self.isEmptyQuiz():
            session = self.REQUEST.SESSION
            qestion_uids = []
            for questionobj in self.objectValues():
                qestion_uids.append(questionobj.UID())
            # if quiz is already set, insist with reset=True
            if not self.REQUEST.SESSION.has_key(self.UID()) and not reset:
                session.set(self.UID(), { 'question_uids' : qestion_uids })
            elif reset:
                del session[self.UID()]
                session.set(self.UID(), { 'question_uids' : qestion_uids })
            return True
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'isInitialized')
    def isInitialized(self):
        """
        """
        session = self.REQUEST.SESSION
        if session.has_key(self.UID()):
            return True
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'isEmptyQuiz')
    def isEmptyQuiz(self):
        """Returns True if quiz is empty, but also init quiz if il is run for the first time
        """
        if self.getQuestionsCount() == 0:
            return True
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'getNextQuestion')
    def getNextQuestion(self, UID=None):
        """Returns the next question object
        """
        session = self.REQUEST.SESSION
        if UID:
            my_index = session[self.UID()]['question_uids'].index(UID)
            if my_index +1 <= len(session[self.UID()]):
                return self.objectValues(['QuizQA'])[my_index + 1]
            else:
                #we are on the last object from list
                return False
        else:
            #donne la 1ere
            return self.objectValues(['QuizQA'])[0]

    security.declareProtected(CMFCorePermissions.View, 'getQuestionObj')
    def getQuestionObj(self, uid=None):
        """Returns the question object
        """
        session = self.REQUEST.SESSION
        if len(session[self.UID()]['question_uids']) != len(self.objectValues(['QuizQA'])):
            #this happens if we remove questions from Quiz
            self.initQuiz(reset=True)
        if uid:
            my_index = session[self.UID()]['question_uids'].index(uid)
            if my_index + 1  <= len(session[self.UID()]['question_uids']):
                return self.objectValues(['QuizQA'])[my_index]
            else:
                #we are on the last object from list
                return False
        else:
            #donne la 1ere
            return self.objectValues(['QuizQA'])[0]

    security.declareProtected(CMFCorePermissions.View, 'getAllQuestions')
    def getAllQuestions(self):
        """
        """
        return self.objectValues(['QuizQA'])

    security.declareProtected(CMFCorePermissions.View, 'getNextQuestionUID')
    def getNextQuestionUID(self, uid=None):
        """ Returns the object uid after the one with given uid
             if no uid param is specified the first one is returned
        """
        session = self.REQUEST.SESSION
        if uid:
            my_index = session[self.UID()]['question_uids'].index(uid)
            if my_index + 1  < len(session[self.UID()]['question_uids']):
                return  session[self.UID()]['question_uids'][my_index + 1]
            else:
                #we are on the last object from list
                session[self.UID()]['last_question'] = True
                return False
        else:
            return  session[self.UID()]['question_uids'][0]


    security.declareProtected(CMFCorePermissions.View, 'getQuestionsCount')
    def getQuestionsCount(self):
        """ Returns the number of QuizQA object in the
            current Quiz folder > rewrite, use data from session
        """
        return len(self.objectValues(['QuizQA']))

    security.declareProtected(CMFCorePermissions.View, 'isAnswered')
    def isAnswered(self):
        """
        """
        if self.REQUEST.SESSION.has_key(self.UID()):
            return self.REQUEST.SESSION[self.UID()].get('last_question', False)
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'getCurrentUID')
    def getCurrentUID(self):
        """
        """
        session = self.REQUEST.SESSION[self.UID()]
        if not session.has_key('current_uid'):
            self.setCurrentUid()
        return session['current_uid']

    security.declareProtected(CMFCorePermissions.View, 'setCurrentUid')
    def setCurrentUid(self, ansUID=None):
        """Set the ID given in arg as current UID
            If nothing is provided sat the first UID
            in the list
        """
        session = self.REQUEST.SESSION
        if ansUID:
            session[self.UID()]['current_uid'] = ansUID
        else:
            session[self.UID()]['current_uid'] = session[self.UID()]['question_uids'][0]

    security.declareProtected(CMFCorePermissions.View, 'getPosition')
    def getPosition(self, uid):
        """
        """
        session = self.REQUEST.SESSION.get(self.UID(), None)
        if not session:
            self.initQuiz(reset=True)
            return False
        #print "question uids from session: %s"%session['question_uids']
        if uid in  session['question_uids']:
            return session['question_uids'].index(uid) + 1
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'canSetDefaultPage')
    def canSetDefaultPage(self):
        """ to bevahe as content type, not folderish"""
        return False


    security.declareProtected(CMFCorePermissions.View, 'getQuizAnswers')
    def getQuizAnswers(self):
        """Return provided answers
        """
        session = self.REQUEST.SESSION
        myself = self.UID()
        if session.has_key(myself) and session[myself].has_key('answers'):
            #session[uid] contains current quiz data
            return session[myself]['answers']
        else:
            return False


    security.declareProtected(CMFCorePermissions.View, 'submitToCorrector')
    def submitToCorrector(self, quaid="QuizQA"):
        """
        """
        questions = self.objectValues([quaid])
        user_answers = self.getQuizAnswers()
        #normaly we have the same number
        #       of answers and questions
        if len(questions) != len(user_answers):
            self.initQuiz(reset=True)
            return False
        count_good_answers = 0

        #this list will store corrections
        correction = []
        for question in questions:

            if question.validateMyAnswer(user_answers[question.UID()]):
                good = True
                count_good_answers += 1
                answer_msg = question.getRightAnswerMessage()
            else:
                good = False
                answer_msg = question.getWrongAnswerMessage()
            correction.append({'question_uid'       : question.UID(),
                               'users_answer'   : ', '.join(user_answers[question.UID()]),
                               'is_correct'     : good,
                               'answer_message' : answer_msg
                               })
        percents = count_good_answers / float(len(questions))
        percents_int = int(round(percents * 100,0))
        report = { 'q_count'            : len(questions) ,
                   'good_answers_count' : count_good_answers,
                   'good_answers_rate'  : percents_int
                    }
        #unused
        #out = {'report'    : report,
               #'correction': correction
               #}
        session = self.REQUEST.SESSION[self.UID()]
        session['report'] = report
        session['corrected'] = True
        session['correction'] = correction

        #classification staff
        my_class = self.getScoreGrpoup(percents)
        #init STATISTICS if void
        # This list contains users results
        self.score_history = getattr(self, 'score_history', [])
        
        if not self.isViewed():
            self.score_history.append(percents)
            self.score_history = self.score_history

        if my_class == REZULT_CLASSES[1]:
            score_title = self.getTitleVeryBadScore()
            score_message = self.getMessageVeryBadScore()
        elif my_class == REZULT_CLASSES[2]:
            score_title = self.getTitleBadScore()
            score_message = self.getMessageBadScore()
        elif my_class == REZULT_CLASSES[3]:
            score_title = self.getTitleGoodScore()
            score_message = self.getMessageGoodScore()
        else:
            score_title = self.getTitleVeryGoodScore()
            score_message = self.getMessageVeryGoodScore()
        session['messages'] = (score_title, score_message)

        return True

    security.declareProtected(CMFCorePermissions.View, 'getQuizStats')
    def getQuizStats(self):
        scores = self.score_history
        result = { REZULT_CLASSES[1] : 0,
                   REZULT_CLASSES[2] : 0,
                   REZULT_CLASSES[3] : 0,
                   REZULT_CLASSES[4] : 0 }
        for score in self.score_history:
            result[self.getScoreGrpoup(score)] += 1

        total = sum(result.values())
        for key in result.keys():
	    if total == 0:
	        total = 1
            result[key] = round(result[key] * 100.0 / total , 2)
        return result

    security.declareProtected(CMFCorePermissions.View, 'getEdges')
    def getEdges(self):
        count_questions = self.getQuestionsCount()
        one = int(floor(0.25 * count_questions))
        two = int(floor(0.5 * count_questions))
        thre = int(floor(0.75 * count_questions))
        edges = ( (0,       one),
                  (one + 1, two),
                  (two + 1, thre),
                  (thre +1 , count_questions)
                 )
        return edges


    security.declareProtected(CMFCorePermissions.View, 'isMyScoreClass')
    def isMyScoreClass(self, myscoreclass):
        session = self.REQUEST.SESSION[self.UID()]
        messages = session.get('messages', None)

        if messages and (messages[0] == myscoreclass):
            return "boldline"
        else:
            return "normaline"

    security.declareProtected(CMFCorePermissions.View, 'getScoreGrpoup')
    def getScoreGrpoup(self, ga_rate):
        # ga_rate -> users Good Answers Rate
        #
        if ga_rate <= 0.25:
            return REZULT_CLASSES[1]
        elif ga_rate <= 0.5:
            return REZULT_CLASSES[2]
        elif ga_rate <= 0.75:
            return REZULT_CLASSES[3]
        else:
            return REZULT_CLASSES[4]


    security.declareProtected(CMFCorePermissions.View, 'getGoodAnswersRate')
    def getGoodAnswersRate(self):
        """
        """
        session_data = self.REQUEST.SESSION[self.UID()]
        if session_data.has_key('report'):
            return session_data['report']['good_answers_rate']
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'getGoodAnswersRateMsg')
    def getGoodAnswersRateMsg(self):
        """
        """
        rate = self.getGoodAnswersRate()
        rate_msg = "%s %s"%(rate, self.translate('quiz_rezult_legend', default='% of good answers', domain='quiz'))
        return rate_msg


    security.declareProtected(CMFCorePermissions.View, 'getGoodAnswersCount')
    def getGoodAnswersCount(self):
        """
        """
        session_data = self.REQUEST.SESSION[self.UID()]
        if session_data.has_key('report'):
            return session_data['report']['good_answers_count']
        else:
            return False


    security.declareProtected(CMFCorePermissions.View, 'getCorrection')
    def getCorrection(self):
        """
        """
        session_data = self.REQUEST.SESSION[self.UID()]
        if session_data.has_key('correction'):
            return session_data['correction']
        else:
            return False

    security.declareProtected(CMFCorePermissions.View, 'getCommentMessege')
    def getCommentMessege(self):
        """
        """
        session = self.REQUEST.SESSION[self.UID()]
        message = session.get('messages', None)
        if message and message[1]:
            return message[1]
        return False

    security.declareProtected(CMFCorePermissions.View, 'getCommentTitle')
    def getCommentTitle(self):
        """
        """
        session = self.REQUEST.SESSION[self.UID()]
        message = session.get('messages', None)
        if message and message[0]:
            return message[0]
        return False

    security.declareProtected(CMFCorePermissions.View, 'setViewed')
    def setViewed(self):
        """
        """
        session_data = self.REQUEST.SESSION[self.UID()]
        session_data['viewed'] = True

    security.declareProtected(CMFCorePermissions.View, 'unsetViewed')
    def unsetViewed(self):
        """
        """
        session_data = self.REQUEST.SESSION[self.UID()]
        session_data['viewed'] = False

    security.declareProtected(CMFCorePermissions.View, 'isViewed')
    def isViewed(self):
        """
        """
        return self.REQUEST.SESSION[self.UID()].get('viewed', False)

    def getSession(self):
        """Only for debug putpose
        """
        from pprint import pformat
        out = pformat(self.REQUEST.SESSION[self.UID()])
        return out

registerType(Quiz,PROJECTNAME)
# end of class Quiz

##code-section module-footer #fill in your manual code here
##/code-section module-footer



